﻿@using ShopWebApp.Models
@model FilteredGoodsIndexViewModel

@{
    ViewBag.Title = "Goods";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="goods-list-body">
    @HtmlHelpers.BuildGoodsFilterPanel(Model.CategoriesList, Model.Filters, Model.PaginationInfo)

    <div class="goods-list">
        <h2>Goods</h2>

        <p>
            @Html.ActionLink("Create New", "Create", null, new { @class = "btn btn-primary" })
        </p>
        <table class="table table-striped table-bordered table-hover table-sm">
            <tr>
                <th>
                    Id
                </th>
                <th>
                    Category
                </th>
                <th>
                    Title
                </th>
                <th>
                    Price
                </th>
                <th></th>
            </tr>

            @foreach (var item in Model.Collection)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.Id)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Category.CategoryName)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Title)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Price)
                    </td>
                    <td>
                        @Html.ActionLink("Edit", "Edit", new { id = item.Id }, new { @class = "btn btn-outline-primary btn-sm" })
                        @Html.ActionLink("Details", "Details", new { id = item.Id }, new { @class = "btn btn-outline-primary btn-sm" })
                        @Html.ActionLink("Delete", "Delete", new { id = item.Id }, new { @class = "btn btn-outline-danger btn-sm" })
                    </td>
                </tr>
            }

        </table>

        @{
            string MakeUrlString(int pageNumber)
            {
                var routeValues = new RouteValueDictionary();
                routeValues.Add("page", pageNumber);
                if (Model.PaginationInfo.ItemsPerPage != ShopWebApp.Utilities.PaginationInfo.ItemsPerPageDefault)
                    routeValues.Add("maxResults", Model.PaginationInfo.ItemsPerPage);
                if (Model.Filters.SelectedCategories.Count > 0)
                {
                    var categories = String.Join(",", Model.Filters.SelectedCategories);
                    routeValues.Add("categories", categories);
                }

                return Url.Action("Index", "Goods", routeValues);
            }
        }
        @HtmlHelpers.BuildPagination(Model.PaginationInfo, MakeUrlString)
    </div>
</div>